<script setup lang="ts">
import { ref, onMounted } from 'vue';
import type { MktoFormInstance, BaseForm } from '@/types/base';
import { ChevronLgRight } from 'slippers-ui/icons';
import { useRouter, useRoute } from 'vue-router';
const { t } = useI18n();

const props = defineProps<BaseForm>();

const submitted = ref(false);
const error = ref(false);

const router = useRouter();
const route = useRoute();

const emit = defineEmits(['submit']);

const formName = computed(() => props.config?.formName || 'mktoFormFill_uncaught');

// Validations
if (!props.config?.formId) {
  console.error(
    `Marketo Form error for ${route.path}: formId is required but missing in the Marketo Form used on this page.`,
  );
  throw new Error();
}

if (!props.config?.formName) {
  console.warn(
    `Marketo Form warning for ${route.path}: formName is not provided in BaseForm with formId: ${props.config?.formId}. Using fallback value "mktoFormFill_uncaught".`,
  );
}

useHead({
  script: [
    {
      src: '//page.gitlab.com/js/forms2/js/forms2.min.js',
      type: 'text/javascript',
      defer: true,
    },
  ],
});

onMounted(() => {
  window.MktoForms2.setOptions({
    formXDPath: '/rs/194-VVC-221/images/marketo-xdframe-relative.html',
  });

  window.MktoForms2.loadForm(
    '//page.gitlab.com',
    '194-VVC-221',
    props.config?.formId,
    (form: MktoFormInstance | null) => {
      if (!form) {
        error.value = true;
        return;
      }

      form.onSuccess(() => {
        emit('submit');
        submitted.value = true;

        window.dataLayer.push({
          event: formName.value,
          mktoFormId: form.getId(),
          eventCallback() {
            form.getFormElem().hide();
          },
          eventTimeout: 3000,
        });

        // Redirect to the submitted message
        router.push('#submitted');

        return false; // Prevent the default form submission
      });

      // Google Analytics ID retrieval
      function getgacid() {
        try {
          const tracker = ga.getAll()[0];
          return tracker.get('clientId');
        } catch (e) {
          return e;
        }
      }

      // Add Google Analytics ID to the form
      form.vals({
        gacid: getgacid(),
      });
    },
  );
});
</script>

<template>
  <div class="form_column">
    <div v-if="config.formId" class="form_container">
      <div v-if="error" class="error">
        <SlpTypography tag="p" variant="heading4-bold"> {{ t('forms.error') }} </SlpTypography>
        <div class="error-buttons">
          <SlpButton data-ga-name="ultimate" data-ga-location="body" variant="primary" href="/pricing/ultimate/">
            {{ t('forms.cta.ultimate') }}
            <SlpIcon :icon="ChevronLgRight" />
          </SlpButton>
          <SlpButton data-ga-name="premium" data-ga-location="body" variant="secondary" href="/pricing/premium/">
            {{ t('forms.cta.premium') }}
            <SlpIcon :icon="ChevronLgRight" />
          </SlpButton>
        </div>
      </div>
      <div v-else>
        <SlpTypography v-if="formHeader && !submitted" tag="h2" variant="heading3" class="form_header">
          {{ formHeader }}
        </SlpTypography>
        <SlpTypography v-if="!submitted" tag="p" variant="body1" class="required_label">
          {{ formRequiredText || t('forms.allFieldsRequired') }}
        </SlpTypography>
        <form v-if="!submitted" :id="`mktoForm_${config.formId}`" class="mktoForm_container" />
        <div v-else id="submitted-message" class="submitted_message">
          <SlpTypography tag="h3" variant="heading3">
            {{ submittedMessage?.header ?? 'Submission received!' }}
          </SlpTypography>
          <SlpTypography tag="p" variant="body1" class="slp-mt-32">
            {{ submittedMessage?.body ?? `We'll be in contact shortly.` }}
          </SlpTypography>
        </div>
      </div>
    </div>
    <iframe v-if="externalForm" :src="externalForm.url" :width="externalForm.width" :height="externalForm.height" />
  </div>
</template>

<style lang="scss" scoped>
.form_column {
  grid-area: form;

  @media (max-width: $breakpoint-lg) {
    margin-bottom: 3rem;
  }

  iframe {
    display: block;
    margin-left: auto;
    margin-right: auto;
    max-width: 100%;
    border: 1px solid #f2f2f2;
    border-radius: 4px;

    .sid-ltr {
      background-color: white;
    }
  }

  .form_container {
    position: relative;
    background: inherit;
    padding: inherit;
    border: inherit;
    border-radius: 4px;

    .error {
      padding: $spacing-32;
    }
    .error-buttons {
      margin: $spacing-24 0 0 0;

      .slp-btn {
        &:first-of-type {
          margin-bottom: $spacing-8;
        }
        .slp-icon {
          margin-left: $spacing-8;
        }

        @media (max-width: $breakpoint-md) {
          padding: 11px $spacing-16;
          width: 100%;
          justify-content: center;

          .slp-icon {
            display: none;
          }
        }
      }
    }
  }

  .form {
    text-align: left;
  }
}

.form_header {
  text-align: center;
  margin-top: $spacing-16;

  @media (min-width: $breakpoint-md) {
    margin-top: 0;
  }

  &--align-left {
    text-align: left;
    @media (max-width: $breakpoint-sm) {
      margin-left: 10px;
    }
  }
}

hr {
  height: 1px;
  border: none;
  background-color: #e8e7eb;
  margin: $spacing-16 0;
}

.required_label {
  margin: 1rem 0;
  font-size: 16px;
  @media (max-width: $breakpoint-sm) {
    padding-left: 10px;
  }
}

.submitted_message {
  text-align: center;
  width: 100%;

  @media (max-width: $breakpoint-lg) {
    padding: 10px;
  }
}
</style>

<!-- prettier-ignore -->
<style lang="scss"> // eslint-disable-line vue-scoped-css/enforce-style-type
// Leave this unscoped so it can override client-side styles from Marketo
.mktoLabel {
  text-transform: lowercase !important;

  &::first-letter {
    text-transform: uppercase;
  }
}

// Override Marketo's label styles
.mktoForm .mktoRequiredField label.mktoLabel,
.mktoForm_container .mktoFieldWrap label {
  color: $color-text-300;
  font-size: 14px;
  font-weight: 400 !important;
}

.mktoForm .mktoRequiredField .mktoAsterix {
  display: none !important;
}

// Override Marketo's input styles
.mktoForm.mktoLayoutAbove .mktoField,
.mktoFieldWrap input:not([type='checkbox']):not([type='radio']):not([type='hidden']),
.mktoFieldWrap select {
  border: 1px solid $color-surface-700;
  border-radius: 4px;
  color: #666;
  display: block;
  font-size: 14px;
  margin-top: 0.4rem;
  outline: none;
  padding: 1em;
  width: 100%;
  &:focus {
    box-shadow: 0 0 4px 1px rgba(0, 0, 0, 0.25);
  }
}

.mktoForm_container .mktoButtonRow {
  width: 100% !important;

  .mktoButtonWrap {
    margin-left: 0px !important;
  }
}

.mktoForm button.mktoButton,
.mktoButtonRow .mktoButtonWrap button {
  display: inline-block;
  text-align: center;
  vertical-align: middle;
  padding: 16px;
  border-radius: 4px;
  font-weight: 600;
  font-size: 16px;
  line-height: 1;
  background-color: $color-primary-200 !important;
  color: $color-text-50 !important;
  border: 1px solid $color-primary-200 !important;
  transition: all 0.3s ease-in-out;
  width: 100% !important;

  &:hover {
    background-color: $color-primary-300 !important;
    color: $color-text-300 !important;
  }
}

.mktoForm .mktoError {
  position: unset !important;

  div.mktoErrorMsg {
    background: transparent;
    color: #333;
    border: none;
    box-shadow: none;
    display: inline;
    font-size: 12px;
    line-height: 20px;

    span.mktoErrorDetail {
      display: inline;
    }
  }
}

.mktoForm_container {
  width: 100% !important;

  a:not(.btn):not(.slp-btn) {
  color: #7d2bd9;

  &:active,
  &:hover,
  &:focus {
    color: #7d2bd9;
  }
}

  .mktoField:not([type='radio']) {
    min-height: 48px;
  }

  .mktoFormRow input:not([type='radio']) {
    width: 100%;
  }

  .mktoHasWidth {
    width: 100% !important;
  }

  .mktoHtmlText {
    margin: 16px 0;
  }

  .mktoFieldWrap,
  .mktoFormCol,
  #commentCapture {
    width: 100%;
    margin-bottom: 0;
  }

  .mktoLogicalField.mktoCheckboxList {
    display: flex;

    input[type='checkbox'] {
      width: 30px !important;
    }

    label {
      margin-left: 0.5rem;
      margin-bottom: 4px;
      display: flex;
      align-items: center;
    }
  }
}

div.mktoErrorArrowWrap {
  display: none;
}

div.mktoOffset {
  display: none !important;
}

div.mktoGutter.mktoHasWidth {
  height: 0 !important;
  margin-bottom: 8px !important;
}

// for groups of checkboxes so that they sit in 2 columns
fieldset {
  border: 0;
  margin-top: $spacing-8;
  padding: 0;

  legend {
    color: $color-primary-200;
    text-transform: lowercase;
    margin: 0 0 $spacing-8 0;
    font-size: 14px;
    padding: 0;

    &::first-letter {
      text-transform: uppercase;
    }
  }
}

.mktoForm fieldset .mktoFieldWrap {
  &:has(.mktoLogicalField) {
    display: flex;
    gap: 10px;
    flex-direction: row-reverse;
    align-items: center;

    .mktoGutter {
      display: none;
    }

    .mktoLogicalField {
      width: 25px !important;
      margin: 0;
      input {
        min-height: 0;
      }
    }
  }
}

.mktoForm .mktoFormCol {
  width: 100%;

  &:has(.mktoLogicalField) {
    display: flex;
    flex-wrap: wrap;
    width: 100%;

    label {
      font-size: 14px;
    }

    .mktoFormRow {
      width: 100%;

      @media (min-width: $breakpoint-md) {
        width: 50%;
      }

      .mktoOffset {
        display: none;
      }
    }
  }
}
</style>
